package com.example.demo

import com.fasterxml.jackson.databind.ObjectMapper
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.toList
import kotlinx.coroutines.reactor.awaitSingle
import org.springframework.core.io.buffer.DataBuffer
import org.springframework.core.io.buffer.DefaultDataBufferFactory
import org.springframework.web.reactive.function.server.ServerRequest
import org.springframework.web.reactive.function.server.ServerResponse
import org.springframework.web.reactive.function.server.bodyToFlow

val dataBufferFactory = DefaultDataBufferFactory()
val objectMapper = ObjectMapper()

class DemoService {
    suspend fun endpoint(request: ServerRequest): ServerResponse {
        val user = request.bodyToFlow(DataBuffer::class).parseUserDto("Hello")
        return ServerResponse.ok().bodyValue(user).awaitSingle()
    }

    private suspend fun Flow<DataBuffer>.parseUserDto(
        param: String,
    ): UserDto {
        println(param)

        return dataBufferFactory.join(toList()).asInputStream().use {
            objectMapper.readValue(it, UserDto::class.java)
        }
    }
}
